package com.ruoyi.dimp.controller;

import java.util.Arrays;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.dimp.domain.DMarketsubDataInfo;
import com.ruoyi.dimp.service.IDMarketsubDataInfoService;
import com.ruoyi.system.domain.BladeRegion;
import com.ruoyi.system.service.IBladeRegionService;
import com.ruoyi.utils.BladeRegionUtils;

/**
 * 市场主体数据导入Controller
 *
 * @author ruoyi
 * @date 2023-03-19
 */
@RestController
@RequestMapping("/dimp/dMarketsubDataInfo")
public class DMarketsubDataInfoController extends BaseController {
	private final IDMarketsubDataInfoService dMarketsubDataInfoService;
    @Autowired
    private IBladeRegionService bladeRegionService;
	public DMarketsubDataInfoController(IDMarketsubDataInfoService dMarketsubDataInfoService) {
		this.dMarketsubDataInfoService = dMarketsubDataInfoService;
	}

	/**
	 * 查询市场主体数据导入列表
	 *
	 * @param dMarketsubDataInfo 市场主体数据导入
	 * @return 市场主体数据导入集合
	 * @date 2023-03-19
	 */
	@PreAuthorize("@ss.hasPermi('dimp:dMarketsubDataInfo:list')")
	@GetMapping("/list")
	public TableDataInfo list(DMarketsubDataInfo dMarketsubDataInfo) {
		String cityCode=null;
		if(StringUtils.isNotBlank(dMarketsubDataInfo.getCityCode()) && ! "53".equals(dMarketsubDataInfo.getCityCode())) {
			cityCode=dMarketsubDataInfo.getCityCode().trim();
		}
		dMarketsubDataInfo.setCityCode(null);
		if(StringUtils.isNotBlank(cityCode)) {
			BladeRegion bladeRegion = BladeRegionUtils.selectByCode(cityCode);
			if(bladeRegion!=null) {
				dMarketsubDataInfo.setCityName(bladeRegion.getCityName());
			}
		}
		startPage();
		List<DMarketsubDataInfo> list = dMarketsubDataInfoService.queryList(dMarketsubDataInfo);
		return getDataTable(list);
	}

	/**
	 * 导出市场主体数据导入列表
	 *
	 * @param dMarketsubDataInfo 市场主体数据导入
	 * @date 2023-03-19
	 */
	@PreAuthorize("@ss.hasPermi('dimp:dMarketsubDataInfo:export')")
	@PostMapping("/export")
	public void export(HttpServletResponse response, DMarketsubDataInfo dMarketsubDataInfo) {
		List<DMarketsubDataInfo> list = dMarketsubDataInfoService.list(new QueryWrapper<>());
		ExcelUtil<DMarketsubDataInfo> util = new ExcelUtil<>(DMarketsubDataInfo.class);
		util.exportExcel(response, list, "市场主体数据导入数据");
	}

	/**
	 * 获取市场主体数据导入详细信息
	 *
	 * @param id 主键id
	 * @return 结果
	 * @date 2023-03-19
	 */
	@PreAuthorize("@ss.hasPermi('dimp:dMarketsubDataInfo:query')")
	@GetMapping(value = "/{id}")
	public AjaxResult getInfo(@PathVariable("id") Long id) {
		return AjaxResult.success(dMarketsubDataInfoService.getById(id));
	}

	/**
	 * 新增市场主体数据导入信息
	 *
	 * @param dMarketsubDataInfo 市场主体数据导入
	 * @return 结果
	 * @date 2023-03-19
	 */
	@PreAuthorize("@ss.hasPermi('dimp:dMarketsubDataInfo:add')")
	@Log(title = "市场主体数据导入", businessType = BusinessType.INSERT)
	@PostMapping
	public AjaxResult add(@RequestBody DMarketsubDataInfo dMarketsubDataInfo) {
		return toAjax(dMarketsubDataInfoService.save(dMarketsubDataInfo));
	}

	/**
	 * 修改市场主体数据导入信息
	 *
	 * @param dMarketsubDataInfo 市场主体数据导入
	 * @return 结果
	 * @date 2023-03-19
	 */
	@PreAuthorize("@ss.hasPermi('dimp:dMarketsubDataInfo:edit')")
	@Log(title = "市场主体数据导入", businessType = BusinessType.UPDATE)
	@PutMapping
	public AjaxResult edit(@RequestBody DMarketsubDataInfo dMarketsubDataInfo) {
		return toAjax(dMarketsubDataInfoService.updateById(dMarketsubDataInfo));
	}

	/**
	 * 删除市场主体数据导入信息
	 *
	 * @param ids 主键ids
	 * @return 结果
	 * @date 2023-03-19
	 */
	@PreAuthorize("@ss.hasPermi('dimp:dMarketsubDataInfo:remove')")
	@Log(title = "市场主体数据导入", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
	public AjaxResult remove(@PathVariable Long[] ids) {
		return toAjax(dMarketsubDataInfoService.removeByIds(Arrays.asList(ids)));
	}

}
